uulib-0.9.15: Haskell Utrecht Tools Library

Safe Haskell | Safe-Inferred

UU.Util.PermTree

# Documentation

data Perms p a Source

Constructors

Choice (Maybe a) [Branch p a] |

Instances

Functor (Perms p) |

data Branch p a Source

Constructors

forall x . Br (p x) (Perms p (x -> a)) |

Instances

Functor (Branch p) |

add :: Maybe a -> p a -> Perms p (a -> b) -> Perms p bSource

empty :: a -> Perms p aSource

(<$$>) :: (a -> b) -> p a -> Perms p bSource

(<$?>) :: (a -> b) -> (a, p a) -> Perms p bSource

(<||>) :: Perms p (a -> b) -> p a -> Perms p bSource

(<|?>) :: Perms p (a -> b) -> (a, p a) -> Perms p bSource